/**
  *  @description ajax简单封装 不依赖jquery 减少代码量 仿jquery api
  * option
  *   type: get
  *   dataType: 'json' //默认都是json
  *   success:
  *   error:
  *   complete: 
  */
function ajax (option) {
	let xmlHttp;
	let emptyFn = function () {};
	let successFn = option.success || emptyFn;
	let errorFn = function (msg) {
		error(msg);
		if (option.error) {
			option.error(msg);	
		}
	}
	let completeFn = option.complete || emptyFn;
	//创建对象
	if (window.XMLHttpRequest) {
		xmlHttp = new XMLHttpRequest();			
	} else {
		xmlHttp = new ActiveXObject('Microsoft.XMLHTTP');	
	}
	option.type = option.type || 'get';
	let method = option.type.toLowerCase();
	let data = "";
	if (option.data) {
		data = data2String(option.data);	
	} 
	/*
	if (method == 'get') {
		option.url += '?' + data + '&_=' + Date.now();
	}
	*/
	if (method == 'get' && data) {
		option.url += '?' + data; 
	}
	xmlHttp.open(option.type, option.url, true);
	switch (method) {
		case "get":
			xmlHttp.send(null);
			break;
		case "post":
			//设置请求头
			xmlHttp.setRequestHeader("Content-type","application/x-www-form-urlencoded");
			xmlHttp.send(data);
			break;
	}
	xmlHttp.onreadystatechange = function () {
		if (xmlHttp.readyState==4 && xmlHttp.status==200) {
			let json;
			let complete = option.complete || emptyFn;
			try {
				json = JSON.parse(xmlHttp.responseText);
			} catch (error) {
				errorFn.call(null, error);
				complete.call();
			}
			if (json) {
				if (json.success) {
					successFn.call(null, json.data);
				} else {
					errorFn.call(null, json.errorMsg);
				}
				completeFn.call();
			}
		}
	}
}
//object {a: 1, b:2} 转换为  a=1&b=2
function data2String (query) {
	let rs = [];
	if (typeof query == 'object') {
		for (var p in query) {
			let cur = query[p];
			let r = cur;
			if (typeof cur == 'object' && cur != null) {
				try {
					r = JSON.stringify(cur)
				} catch (error) {
					console.log('parse error');	
				}
			} 
			rs.push([p, r].join('='));	
		}
	} else {
		return query;		
	}
	return rs.join('&')
}
function error (msg) {
	console.error(msg);	
}
export default ajax;
