/**
 * @description 组件的汇聚类， 输入，输出
 * @params
 */
import React from 'react';
import DCom from './dcom.jsx';
import 'normalize.css';
import './index.less';
import Ajax from './ajax.js';
import url from './url';
export default class App extends React.Component {
	constructor (props) {
		super(props);	
		this.state = {
			data: null
		};
		this.children = [];
	}
	init () {
		let option = this.props.option;
		Ajax({
			url: url('/profile/api/crowd/tag/getTagList.json', 2),	
			//初始化参数
			data: {
				functionId: option.functionId,
				categoryIds: option.categoryIds.join()
			},
			success: function (res) {
				this.setState({
					data: res			
				});	
			}.bind(this)
		});
	}

	//筛选人群
	filter () {
		let children = this.children || [];
		let values = [];
		children.map(function (item) {
			let v = item.getValue();
			if (v) {
				values.push(v);	
			}
		});
		let params = {
			"childrenRules": [],
			"relForChildren": "AND",
			"relForSelf": "AND",
			"relForSelfAndChildren": "AND",
			"selfItems": []
		};
		params.childrenRules = values;
		Ajax({
			url: url('/profile/api/crowd/saveCrowdDefinition.json'),
			type: 'POST',
			data:  {
				functionId: this.props.option.functionId,	
				ruleJsonText: JSON.stringify(params)  		
			},
			success: function (data) {
				console.log(data);	
			}
		});
	}
	renderCom (data) {
		let child = null;			
		child = data.map(function (item, index) {
			let child = null;
			if (item.children) {
				child = (
					<div className="category-item">
						<h3>{item.name}</h3>
						{this.renderCom(item.children)}
					</div>			
				);
			} else {
				/*
				if (!item.configInfo) {
					item.configInfo = {};	
				}
				*/
				if (!item.configInfo) {
					child = null;
				} else {
					child = (
						<DCom ref={(c) => this.children.push(c)} 
							filter={this.filter.bind(this)} 
							option={item}>
						</DCom>
					);			
				}
				/*
				child = (
					<DCom ref={(c) => this.children.push(c)} 
						filter={this.filter.bind(this)} 
						option={item}>
					</DCom>
				);			
				*/
			}	
			return (
				<li key={item.id}>
					{child}
				</li>			
			);
		}.bind(this));
		return (
			<ul className="category">
				{child}
			</ul>			
		);
	}
	render () {
		let data = this.state.data;
		let child = null;
		if (data) {
			child = this.renderCom(data);
		} else {
			this.init();
			child = null;
		}
		return (
			<div className="app">
				{child}
			</div>			
		);
	}
}
