/**
  * @description 级联标签 by wb-dy201581
 */
import React from 'react';
import Cascader from 'antd/lib/cascader/index.js'; 
import CascaderStye from 'antd/lib/cascader/style/index.js'; 
import Ajax from './ajax.js';
import url from './url.js';
export default class CascadeLabel extends React.Component {
	constructor (props) {
		super(props);	
		this.state = {
			data: null,
			//记录是数据的那个子节点
			pos: null,
			//以value 为key 的索引序列
			v2v: {},
			params: {
				//当前的id
				tagId: props.option.id,
				//父级id
				parentTagId: '',
				//父级值
				parentTagValue: '' 
			}
		};
	}
	onChange(value){
		if (value.length == 0) {
			//清空	
			return;
		}
		let state = this.state;
		let v2v = state.v2v;
		let lastValue = value[value.length - 1];
		let cur = v2v[lastValue];
		//记录父级的值
		let params = state.params;
		params.parentTagValue = lastValue;
		params.parentTagId = cur.id;
		if (cur.child) {
			params.tagId = cur.child.id;
		} else {
			if (value) {
				this.setValue(value);
			} else {
				this.setValue("null");
			}
			this.props.filter();	
			return;
		}
		this.query(cur);
		if (value) {
			this.setValue(value);
		} else {
			this.setValue("null");
		}
		this.props.filter();
	 }
	 
	setValue(value){
		this.radio = value;
	}

	getValue () {
		let v2v = this.state.v2v;
		let value = this.radio;
		if (!value) {
			return;	
		}
		let chilrenRules = [];
		for (let i = 0; i < value.length; i++) {
			let cur = value[i];
			let tmp = v2v[cur];
			if (!tmp) {
				break;	
			}
			let params = {
				"childrenRules": [],
				"relForChildren": "AND",
				"relForSelf": "AND",
				"relForSelfAndChildren": "AND",
				"selfItems": [{
					"code": tmp.code,
					"id": tmp.id,
					"name": tmp.name,
					"value": {
						"@class": "com.alipay.antdac.profile.common.service.facade.model.NormalPropertyValue",
						"value": cur,
						"valueOperator": "EQ",
						"valueType": "STRING"
					}	
				}]
			};
			childrenRules.push(params);
		}
		if (childrenRules.length > 0) {
			return {
				"childrenRules": childrenRules,
				"relForChildren": "AND",
				"relForSelf": "AND",
				"relForSelfAndChildren": "AND",
				"selfItems": []
			}; 	
		} else {
			return;	
		}
	}
	filter (params) {
		let data = {};
		//过滤空值
		for (var p in params) {
			if (params[p]) {
				data[p] = params[p];	
			}	
		}
		return data;
	}
	//查询当前一级的数据
	/**
	  * @description 查询当前级别的数据
	  * @params
	  * {
	  *   tagId
	  *   parentTagId
	  *	  parentTagValue
	  *	}
	  */
	query (cur) {
		let state = this.state;
		let v2v = state.v2v;
		let option = {
			url: url('/profile/api/crowd/tag/getTagValue.json'),	
			data: this.filter(state.params),
			success: function (res) {
				let v2v = {};
				let data = res.values;
				data.map(function (item) {
					item.label = item.name;
					item.id = res.id;
					item.name = res.name;
					item.code = res.code;
					if (res.cascadeChild) {
						item.child = res.cascadeChild;	
					}
				});
				//记录 以value为key
				data.map(function (item) {
					v2v[item.value] = item;			
				});
				if (cur) {
					cur.children = data;	
				} else {
					state.data = data;	
				}
				this.setState({
					data: state.data,
					v2v: v2v
				});	
			}.bind(this)
		};
		Ajax(option);	
	}

	render () {
		let option = this.props.option; 
		let child = null;
		let data = this.state.data;
		if (!data) {
			this.state.tagId = option.tagId;
			//获取第一级
			this.query();
		} else {
			child = (<Cascader options={data} onChange={this.onChange.bind(this)} placeholder={option.placeholder} />);
		}
		return (
			<div className="cascadelabel">
				{child}
			</div>			
		);
	}
}
