/**
  * @description 离散可枚举的交互组件
  * @params 
  *		type: single, multi  单选复选
  *		position: repeat, 平铺 select 下拉
  */
import React from 'react';
import RadioCom from './radiocom.jsx';
import CheckboxCom from './checkboxcom.jsx';
import SelectSingleCom from './selectsinglecom.jsx';
import SelectMultiCom from './selectmulticom.jsx';
import Ajax from './ajax.js';
import url from './url.js';
import './choicelabel.less';
export default class ChoiceLabel extends React.Component {
	constructor (props) {
		super(props);	
		this.state = {
			data: null,
			changeValue:null	
		};
	}
	init () {
		let option = this.props.option;
		let params= {
			url: url('/profile/api/crowd/tag/getTagValue.json?tagId=' + option.id),	
			success: function (res) {
				this.setState({
					data: res			
				});	
			}.bind(this)
		};
		Ajax(params);	
	}
	changeValue(){
		this.setValue(arguments[0]);
		this.props.filter();
	}
	getValue () {
		let value = this.radio;
		if (!value) {
			return;	
		}
		let option = this.props.option;
		let params = {
			"childrenRules": [],
			"relForChildren": "AND",
			"relForSelf": "AND",
			"relForSelfAndChildren": "AND",
			"selfItems": [{
				"code": option.code,
				"id": option.id,
				"name": option.name,
				"tableCode": this.props.tableCode 
			}]
		};
		let tmp = params.selfItems[0];
		if (value instanceof Array) {
			//数组
			tmp.value = {
				"@class": "com.alipay.antdac.profile.common.service.facade.model.DiscretePropertyValue",
				"valueOperator": "IN",
				"values": value,
				"valueType": "STRING"
			};	
		} else {
			//单值	
			tmp.value = {
				"@class": "com.alipay.antdac.profile.common.service.facade.model.NormalPropertyValue",
				"value": value,
				"valueOperator": "EQ",
				"valueType": "STRING"
			};	
		}
		return params;
	}
	setValue(value){
		this.radio = value;
	}
	render () {
		let option = this.props.option; 
		let child = null;
		let data = this.state.data;
		if (!data) {
			this.init();
			return (
				<div className="choice"></div>			
			);	
		}
		let configInfo = option.configInfo || {};
		switch (configInfo.showType) {
			case "radio":
				//平铺单选
				child = <RadioCom onChange={this.changeValue.bind(this)} data={data} option={option}/>;
				break;
			case "checkbox":
				//平铺多选
				child = <CheckboxCom onChange={this.changeValue.bind(this)}  data={data} option={option} />;
				break;
			case "selectsingle":
				//下拉单选
				child = <SelectSingleCom onChange={this.changeValue.bind(this)}  data={data} option={option}/>;
				break;
			case "selectmulti":
				child = <SelectMultiCom onChange={this.changeValue.bind(this)}  data={data} option={option}/>;
				//下拉多选
				break;
		}
		return (
			<div className="choice">
				{child}
			</div>			
		);
	}

}
