/**
  * @description 日期标签组件   by wb-dy201581
 */
import React from 'react';
import DatePicker from 'antd/lib/date-picker/index.js'; 
import DatePickerStye from 'antd/lib/date-picker/style/index.js'; 
const RangePicker = DatePicker.RangePicker;
export default class DateLabel extends React.Component {
	constructor (props) {
		super(props);	
		this.state = {dateValue:this.props.option.value};
	}
	changeTime(date,dateString){
		this.state.dateValue = dateString;
		this.props.filter();	
		this.setState({dateValue:dateString})
	}
	 getValue () {
		let value = this.state.dateValue;	
		if (!value) {
			return;	
		}
		let option = this.props.option;
		let params = {
			"childrenRules": [],
			"relForChildren": "AND",
			"relForSelf": "AND",
			"relForSelfAndChildren": "AND",
			"selfItems": [{
				"code": option.code,
				"id": option.id,
				"name": option.name,
				"tableCode": this.props.tableCode,
			}]
		};
		let tmp = params.selfItems[0];
		let suffix = ' 00:00:00';
		if (value instanceof Array) {
			//数组
			tmp.value = {
				"@class": "com.alipay.antdac.profile.common.service.facade.model.IntervalPropertyValue",
				"maxValue": value[1] + suffix,
				"maxValueOperator": "LE",
				"minValue": value[0] + suffix,
				"minValueOperator": "GE",
				"valueType": "DATE"
			};	
		} else {
			//单值	
			tmp.value = {
				"@class": "com.alipay.antdac.profile.common.service.facade.model.NormalPropertyValue",
				"value": value + suffix,
				"valueOperator": "EQ",
				"valueType": "DATE"
			};	
		}
		return params;
	}
	render () {
		let option = this.props.option.configInfo || {}; 
		option.value =this.state.dateValue;
		let child = null;
			switch (option.valueType) {
			case "value":
				//单个日期组件
				child = <DatePicker  value={this.state.dateValue}  onChange={this.changeTime.bind(this)} format="yyyy-MM-dd" />;
				break;
			case "range":
				//日期区间
				child = <RangePicker value={this.state.dateValue} onChange={this.changeTime.bind(this)} format="yyyy-MM-dd" />;
				break;	
		}
		return (
			<div className="datelabel">
				{child}
			</div>			
		);
	}

}

