/**
 * @description 组件的顶层类，所有子组件均通过当前组件组装
 * @params
 */
import React from 'react';
import './dcom.less';
import ChoiceLabel from './choicelabel.jsx';
import SelectLabel from './selectlabel.jsx';
import NumberLabel from './numberlabel.jsx';
import DateLabel from './datelabel.jsx';
import CascadeLabel from './cascadelabel.jsx';
import InputLabel from './inputlabel.jsx';
import assign from 'object-assign';
import Ajax from './ajax.js';
import url from './url.js';
export default class DCom extends React.Component {
	constructor (props) {
		super(props);	
		this.state = {};
		this.init();
	}
	//获取值
	getValue () {
		if (this.child) {
			return this.child.getValue();	
		} else {
			return null;	
		}
	}
	init () {
		let option = this.props.option;
		let params= {
			url: url('/profile/api/crowd/tag/getTagValue.json?tagId=' + option.id),	
			success: function (res) {
				this.setState({
					tableCode: res.table			
				});
			}.bind(this)
		};
		Ajax(params);	
	}
	render () {
		let child = null;
		let props = this.props;
		let option = props.option;
		let configInfo =  option.configInfo || {};
		let filter = props.filter;
		let tableCode = this.state.tableCode;
		if (!tableCode) {
			this.init();
			child = null;	
		} else {
			//组件的类型
			switch (configInfo.dType) {
				case "choice":
					//离散可枚举标签	
					child = <ChoiceLabel  tableCode={tableCode} ref={ (c)=> this.child = c} filter={filter} option={option}/>;
					break;
				case "select":
					//离散不可枚举标签
					child = <SelectLabel tableCode={tableCode} ref={ (c)=> this.child = c}  filter={filter} option={option}/>;
					break;
				case "number":
					//数值不可枚举标签
					child = <NumberLabel  tableCode={tableCode} ref={ (c)=> this.child = c}  filter={filter} option={option}/>;
					break;
				case "date":
					//连续性日期标签
					child = <DateLabel   tableCode={tableCode} ref={ (c)=> this.child = c} filter={filter} option={option}/>;
					break;
				case "cascade":
					child = <CascadeLabel  tableCode={tableCode} ref={ (c)=> this.child = c} filter={filter} option={option}/>;
					break;
					//级联标签
				default:
					child = <InputLabel tableCode={tableCode} ref={ (c)=> this.child = c} filter={filter} option={option} />;
					break;
			}
		}
		return (
			<div className="dcom">
				<label>{option.name}</label>
				<div className="dcom-content">
					{child}
				</div>
			</div>			
		);
	}
}
