/**
  * @description 连续型数值标签 wb-dy201581
  */
import React from 'react';
import Slider from 'antd/lib/slider/index.js'; 
import SliderStye from 'antd/lib/slider/style/index.js'; 
import InputNumber from 'antd/lib/input-number/index.js'; 
import InputNumberStye from 'antd/lib/input-number/style/index.js'; 
import assign from 'object-assign';
export default class NumberLabel extends React.Component {
	constructor (props) {
		super(props);	
		let configInfo = props.option.configInfo;
		this.state = {
			inputValue: configInfo.value,
			min: configInfo.min || 0,
			max: configInfo.max || 100
		};
	}
	onChange(value) {
		this.state.inputValue = value
		this.props.filter();
		this.setState({
	      inputValue: value,
	    });
	 }
	 onChangeMin(value) {
		if (!this.state.inputValue) {
			this.state.inputValue = [this.state.min, this.state.max];	
		}
	 	var max = this.state.inputValue[1]
	 	this.state.inputValue = [value,max]
		this.props.filter();
	    this.setState({
	      inputValue: [value,max],
	    });
	 }
	  onChangeMax(value) {
		if (!this.state.inputValue) {
			this.state.inputValue = [this.state.min, this.state.max];	
		}
	 	var min= this.state.inputValue[0]
	 	this.state.inputValue = [min,value]
		this.props.filter();
	    this.setState({
	      inputValue: [min,value],
	    });
	 }

	 getValue () {
		let option = this.props.option;
		let value = this.state.inputValue;	
		if (!value) {
			return;	
		}
		let params = {
			"childrenRules": [],
			"relForChildren": "AND",
			"relForSelf": "AND",
			"relForSelfAndChildren": "AND",
			"selfItems": [{
				"code": option.code,
				"id": option.id,
				"name": option.name,
				"tableCode": this.props.tableCode,
			}]
		};
		let tmp = params.selfItems[0];
		if (value instanceof Array) {
			//数组
			tmp.value = {
				"@class": "com.alipay.antdac.profile.common.service.facade.model.IntervalPropertyValue",
				"maxValue": value[1],
				"maxValueOperator": "LE",
				"minValue": value[0],
				"minValueOperator": "GE",
				"valueType": "NUMBER"
			};	
		} else {
			//单值	
			tmp.value = {
				"@class": "com.alipay.antdac.profile.common.service.facade.model.NormalPropertyValue",
				"value": value,
				"valueOperator": "EQ",
				"valueType": "NUMBER"
			};	
		}
		return params;
	 }
	render () {
		let option = this.props.option.configInfo || {}; 
		let min = this.state.min;
		let max = this.state.max;
		let step = option.step || 1;
		let marks =  {};
		marks[min] = min;
		marks[max] = max;
		option.value = this.state.inputValue;
		let value = this.state.inputValue;
		let child = null;
			switch (option.valueType) {
			case "value":
				if (!value) {
					value = 0;	
				}
				//单个数值
				if(option.showType == "input"){
					child =  <div>	      						
					          <InputNumber min={min} max={max}  step={step}  style={{ marginLeft: '20px', marginTop: '5px' }}
					            value={value} onChange={this.onChange.bind(this)}
					          /> 
       				     				     
					      </div>;
				}else if(option.showType == "drag"){
					child =  <div>	      						 
					          <Slider min={min} max={max} step={option.step}  marks={marks} onChange={this.onChange.bind(this)} value={value} />
					      </div>;
				}
				
				break;
			case "range":
				//数字区间
				if (!value) {
					value = [0, 100];	
				}
				if(option.showType == "input"){	
				child = <div>				
		                    <InputNumber value={value[0]}  step={option.step} style={{ marginLeft: '20px', marginTop: '5px' }}  onChange={this.onChangeMin.bind(this)}/>
		                    <span> - </span>
		                    <InputNumber value={value[1]}  step={option.step}  onChange={this.onChangeMax.bind(this)}/>
						</div>				
				}else if(option.showType == "drag"){
					child = <div>
		                    <Slider range defaultValue={value}   min={option.min} max={option.max}  marks={marks} onChange={this.onChange.bind(this)}  step={option.step} />
		               
		                </div>;
		        }
				break;	
		}
		return (
			<div className="numberlabel">
				{child}
			</div>			
		);
	}
}
